/* TIDA-00848 example code Software

Copyright (c) 2016, Texas Instruments Incorporated. All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the distribution.
3. Neither the name of Texas Instruments Incorporated nor the names of its contributors may be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
 */
/** \mainpage Driver Overview
  *
  * \section section_drv_info Driver Information
  * This Sensor Controller Interface driver has been generated by the Texas Instruments Sensor Controller
  * Studio tool:
  * - <b>Project name</b>:     HCACapTouch
  * - <b>Project file</b>:     C:/Users/a0797195/workspace_v6_0/rfPacketTx_CC1310DK_7XD_TI_CC1310F128/sce/HCA.scp
  * - <b>Code prefix</b>:      -
  * - <b>Operating system</b>: TI-RTOS
  * - <b>Tool version</b>:     1.2.0.40562
  * - <b>Target chip</b>:      CC1310, revision -, package QFN48 7x7 RGZ
  * - <b>Created</b>:          2016-03-30 13:09:14.235
  * - <b>Computer</b>:         CNFR-LP-2378
  * - <b>User</b>:             a0797195
  *
  * Do not edit the generated source code files other than temporarily for debug purposes. Any
  * modifications will be overwritten by the Sensor Controller Studio when generating new output.
  *
  * \section section_drv_modules Driver Modules
  * The driver is divided into three modules:
  * - \ref module_scif_generic_interface, providing the API for:
  *     - Initializing and uninitializing the driver
  *     - Task control (for starting, stopping and executing Sensor Controller tasks)
  *     - Task data exchange (for producing input data to and consume output data from Sensor Controller
  *       tasks)
  * - \ref module_scif_driver_setup, containing:
  *     - The AUX RAM image (i.e. Sensor Controller code and data)
  *     - I/O mapping information
  *     - Task data structure information
  *     - Driver setup data, to be used in the driver initialization
  *     - Project-specific functionality
  * - \ref module_scif_osal, for flexible OS support:
  *     - Interfaces with the selected operating system
  *
  * It is possible to use output from multiple Sensor Controller Studio projects in one application. Only
  * one driver setup may be active at a time, but it is possible to switch between these setups. When
  * using this option, there is one instance of the \ref module_scif_generic_interface and
  * \ref module_scif_osal modules, and multiple instances of the \ref module_scif_driver_setup module.
  * This requires that:
  * - The outputs must be generated using the same version of Sensor Controller Studio
  * - The outputs must use the same operating system
  * - The outputs must use different source code prefixes (inserted into all globals of the
  *   \ref module_scif_driver_setup)
  *
  *
  * \section section_project_info Project Description
  * No description entered
  *
  *
  * \subsection section_io_mapping I/O Mapping
  * Task I/O functions are mapped to the following pins:
  * - CapTouchButton:
  *     - <b>AXD: CapTouch Button area on TIDA00848 0</b>: DIO30
  * - LMT70:
  *     - <b>A: Input from LMT70 Sensor 1</b>: DIO27
  *     - <b>A: Input from LMT70 Sensor 2</b>: DIO29
  *     - <b>O: Enable Power Supply pin for Sensor 1 2</b>: DIO28
  *
  *
  * \section section_task_info Task Description(s)
  * This driver supports the following task(s):
  *
  *
  * \subsection section_task_desc_cap_touch_button CapTouchButton
  * Samples the Cap Touch PCB element on TIDA-00848 (CC1310 HCA 1-chip)
  * 
  * The TDC data (i.e. the time taken to charge up each capacitive area from 0 to 0.8 V) are output to
  * the System CPU. This includes raw data.
  * 
  * 
  * \subsection section_task_desc_lmt70 LMT70
  * Sampling of two LMT70A analog temp. sensors
  *
  */




/** \addtogroup module_scif_driver_setup Driver Setup
  *
  * \section section_driver_setup_overview Overview
  *
  * This driver setup instance has been generated for:
  * - <b>Project name</b>:     HCACapTouch
  * - <b>Code prefix</b>:      -
  *
  * The driver setup module contains the generated output from the Sensor Controller Studio project:
  * - Location of task control and scheduling data structures in AUX RAM
  * - The AUX RAM image, and the size the image
  * - Task data structure information (location, size and buffer count)
  * - I/O pin mapping translation table
  * - Task resource initialization and uninitialization functions
  *
  * @{
  */
#ifndef SCIF_H
#define SCIF_H

#include <stdint.h>
#include <stdbool.h>
#include "scif_framework.h"
#include "scif_osal_tirtos.h"


/// Target chip name
#define SCIF_TARGET_CHIP_NAME_CC1310
/// Target chip package
#define SCIF_TARGET_CHIP_PACKAGE_QFN48_7X7_RGZ

/// Number of tasks implemented by this driver
#define SCIF_TASK_COUNT 2

/// CapTouchButton: Task ID
#define SCIF_CAP_TOUCH_BUTTON_TASK_ID 0
/// LMT70: Task ID
#define SCIF_LMT70_TASK_ID 1


/// CapTouchButton: Number of PCB Touch buttons
#define SCIF_CAP_TOUCH_BUTTON_PIN_COUNT 1
/// CapTouchButton I/O mapping: CapTouch Button area on TIDA00848
#define SCIF_CAP_TOUCH_BUTTON_DIO_AXD_PCB_BUTTON { 30 }
/// LMT70 I/O mapping: Input from LMT70 Sensor 1
#define SCIF_LMT70_DIO_A_LMT1_AIN 27
/// LMT70 I/O mapping: Input from LMT70 Sensor 2
#define SCIF_LMT70_DIO_A_LMT2_AIN 29
/// LMT70 I/O mapping: Enable Power Supply pin for Sensor 1 2
#define SCIF_LMT70_DIO_O_LMT_ON 28


// All shared data structures in AUX RAM need to be packed
#pragma pack(push, 2)


/// CapTouchButton: Task configuration structure
typedef struct {
    uint16_t pAuxioAxdPcbButton[1]; ///< I/O mapping: CapTouch Button area on TIDA00848
} SCIF_CAP_TOUCH_BUTTON_CFG_T;


/// CapTouchButton: Task output data structure
typedef struct {
    uint16_t baselineValue; ///< 
    uint16_t pTdcValueFilt; ///< TDC value, filtered
    uint16_t pTdcValueRaw;  ///< TDC Value, raw
} SCIF_CAP_TOUCH_BUTTON_OUTPUT_T;


/// CapTouchButton: Task state structure
typedef struct {
    uint16_t filtInitDone;    ///< Has the value filtering been initialized?
    uint16_t patternDetected; ///< PCB Touch Event flag
    uint16_t threshold;       ///< Variable
} SCIF_CAP_TOUCH_BUTTON_STATE_T;


/// LMT70: Task output data structure
typedef struct {
    uint16_t adcVal1; ///< Readout of first LMT70A
    uint16_t adcVal2; ///< Readout of second LMT70A 
} SCIF_LMT70_OUTPUT_T;


/// Sensor Controller task data (configuration, input buffer(s), output buffer(s) and internal state)
typedef struct {
    struct {
        SCIF_CAP_TOUCH_BUTTON_CFG_T cfg;
        SCIF_CAP_TOUCH_BUTTON_OUTPUT_T output;
        SCIF_CAP_TOUCH_BUTTON_STATE_T state;
    } capTouchButton;
    struct {
        SCIF_LMT70_OUTPUT_T output;
    } lmt70;
} SCIF_TASK_DATA_T;

/// Sensor Controller task generic control (located in AUX RAM)
#define scifTaskData    (*((volatile SCIF_TASK_DATA_T*) 0x400E00EE))


// Initialized internal driver data, to be used in the call to \ref scifInit()
extern const SCIF_DATA_T scifDriverSetup;


// Restore previous struct packing setting
#pragma pack(pop)


// AUX I/O re-initialization functions
void scifReinitTaskIo(uint32_t bvTaskIds);


// RTC-based tick generation control
void scifStartRtcTicks(uint32_t tickStart, uint32_t tickPeriod);
void scifStartRtcTicksNow(uint32_t tickPeriod);
void scifStopRtcTicks(void);


#endif
//@}
